/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __DEATH_EFFECT_H__
#define __DEATH_EFFECT_H__

typedef struct DeathEffect DeathEffect;

#include "3dmath/Vector.h"
#include "convergence/GameObjectView.h"
#include "glgraphics/GLIncludes.h"
#include "gltexture/GLTexture.h"
#include "resourcemanager/ResourceManager.h"

#define DeathEffect_structContents \
	GameObjectView_structContents \
	\
	ResourceManager * resourceManager; \
	GLTexture * texture; \
	Vector2 position; \
	double currentTime; \
	GLuint vboID; \
	GLuint eboID;

struct DeathEffect {
	DeathEffect_structContents
};

DeathEffect * DeathEffect_create(Vector2 position, ResourceManager * resourceManager);
void DeathEffect_init(compat_type(DeathEffect *) selfPtr, Vector2 position, ResourceManager * resourceManager);
void DeathEffect_dispose(compat_type(DeathEffect *) selfPtr);

void DeathEffect_draw(compat_type(DeathEffect *) selfPtr, Matrix modelviewMatrix, double deltaTime);

#endif
