/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYBACK_PLAYER_INPUT_CONTROLLER_H__
#define __PLAYBACK_PLAYER_INPUT_CONTROLLER_H__

typedef struct PlaybackPlayerInputController PlaybackPlayerInputController;

#include "convergence/PlayerInputController.h"
#include "convergence/RecordingPlayerInputController.h"

#define PlaybackPlayerInputController_structContents \
	PlayerInputController_structContents \
	\
	unsigned int frameIndex; \
	size_t nodeIndex; \
	size_t nodeCount; \
	struct RecordedPlayerInputNode * nodes;

struct PlaybackPlayerInputController {
	PlaybackPlayerInputController_structContents
};

PlaybackPlayerInputController * PlaybackPlayerInputController_create(PlayerModel * playerModel, PlayerInputMap * inputMap, const char * fileName);
void PlaybackPlayerInputController_init(compat_type(PlaybackPlayerInputController *) selfPtr, PlayerModel * playerModel, PlayerInputMap * inputMap, const char * fileName);
void PlaybackPlayerInputController_dispose(compat_type(PlaybackPlayerInputController *) selfPtr);

bool PlaybackPlayerInputController_triggerAction(compat_type(PlaybackPlayerInputController *) selfPtr, Atom actionID);
bool PlaybackPlayerInputController_releaseAction(compat_type(PlaybackPlayerInputController *) selfPtr, Atom actionID);
void PlaybackPlayerInputController_update(compat_type(PlaybackPlayerInputController *) selfPtr);

#endif
