/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYER_DUELIST_MODEL_H__
#define __PLAYER_DUELIST_MODEL_H__

typedef struct PlayerDuelistModel PlayerDuelistModel;

#include "convergence/PlayerModel.h"

#define PlayerDuelistModel_structContents \
	PlayerModel_structContents \
	\
	int attackCooldown; \
	Direction swordSwingFacing; \
	bool blocking; \
	Direction blockFacing; \
	int blockBuffRemaining;

struct PlayerDuelistModel {
	PlayerDuelistModel_structContents
};

PlayerDuelistModel * PlayerDuelistModel_create(DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerDuelistModel_init(compat_type(PlayerDuelistModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerDuelistModel_initCopy(compat_type(PlayerDuelistModel *) selfPtr, compat_type(PlayerDuelistModel *) originalPtr);
void PlayerDuelistModel_dispose(compat_type(PlayerDuelistModel *) selfPtr);

compat_type(PlayerDuelistModel *) PlayerDuelistModel_copy(compat_type(PlayerDuelistModel *) selfPtr);
void PlayerDuelistModel_update(compat_type(PlayerDuelistModel *) selfPtr);
bool PlayerDuelistModel_atRest(compat_type(PlayerDuelistModel *) selfPtr);
void PlayerDuelistModel_startAttack(compat_type(PlayerDuelistModel *) selfPtr);
void PlayerDuelistModel_startSpecialAction(compat_type(PlayerDuelistModel *) selfPtr);
void PlayerDuelistModel_stopSpecialAction(compat_type(PlayerDuelistModel *) selfPtr);
void PlayerDuelistModel_knockedBack(compat_type(PlayerDuelistModel *) selfPtr, Vector2 knockback);
void PlayerDuelistModel_takeDamage(compat_type(PlayerDuelistModel *) selfPtr, int amount, Direction fromDirection);

#endif
