/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __RANK_UP_POWERUP_MODEL_H__
#define __RANK_UP_POWERUP_MODEL_H__

typedef struct RankUpPowerupModel RankUpPowerupModel;

#include "convergence/GameObjectModel.h"

#define RANK_INCREASE_POWERUP_RADIUS 0.5f
#define RANK_INCREASE_POWERUP_RATIO (29.0f / 51.0f)

#define RankUpPowerupModel_structContents \
	GameObjectModel_structContents \
	\
	Vector2 position;

struct RankUpPowerupModel {
	RankUpPowerupModel_structContents
};

RankUpPowerupModel * RankUpPowerupModel_create(DungeonRoomStateModel * stateModel, Vector2 position);
void RankUpPowerupModel_init(compat_type(RankUpPowerupModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position);
void RankUpPowerupModel_initCopy(compat_type(RankUpPowerupModel *) selfPtr, compat_type(RankUpPowerupModel *) originalPtr);
void RankUpPowerupModel_dispose(compat_type(RankUpPowerupModel *) selfPtr);

compat_type(RankUpPowerupModel *) RankUpPowerupModel_copy(compat_type(RankUpPowerupModel *) selfPtr);
struct rect4f RankUpPowerupModel_roughBounds(compat_type(RankUpPowerupModel *) selfPtr);
struct collisionGeometry RankUpPowerupModel_collisionGeometry(compat_type(RankUpPowerupModel *) selfPtr);
bool RankUpPowerupModel_wouldCollide(compat_type(RankUpPowerupModel *) selfPtr, compat_type(GameObjectModel *) objectPtr);
void RankUpPowerupModel_collision(compat_type(RankUpPowerupModel *) selfPtr, compat_type(GameObjectModel *) objectPtr, const struct collision collision, float time);

#endif
