/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __RESOURCE_WIRING_H__
#define __RESOURCE_WIRING_H__

#include "resourcemanager/ResourceManager.h"

void * loadPNGFlip(const char * resourceName, void * context);
void * loadTexture(const char * resourceName, void * context);
void * loadTextureCanvas(const char * resourceName, void * context);
void * loadBitmapFont(const char * resourceName, void * context);
void * loadDungeon(const char * resourceName, void * context);
void * loadDungeonRoom(const char * resourceName, void * context);
void * loadOggVorbis(const char * resourceName, void * context);
void unloadPNG(void * resource, void * context);
void unloadTexture(void * resource, void * context);
void unloadTextureCanvas(void * resource, void * context);
void unloadBitmapFont(void * resource, void * context);
void unloadDungeon(void * resource, void * context);
void unloadDungeonRoom(void * resource, void * context);
void unloadOggVorbis(void * resource, void * context);

#endif
