/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __SPARKLE_EFFECT_H__
#define __SPARKLE_EFFECT_H__

typedef struct SparkleEffect SparkleEffect;

#include "3dmath/Vector.h"
#include "convergence/GameObjectView.h"
#include "convergence/PlayerModel.h"
#include "glgraphics/GLIncludes.h"

#define SparkleEffect_structContents \
	GameObjectView_structContents \
	\
	Vector2 position; \
	float radius; \
	PlayerModel * owner; \
	double currentTime; \
	GLuint vboID; \
	GLuint eboID;

struct SparkleEffect {
	SparkleEffect_structContents
};

SparkleEffect * SparkleEffect_create(Vector2 position, float radius, compat_type(PlayerModel *) owner);
void SparkleEffect_init(compat_type(SparkleEffect *) selfPtr, Vector2 position, float radius, compat_type(PlayerModel *) owner);
void SparkleEffect_dispose(compat_type(SparkleEffect *) selfPtr);

void SparkleEffect_draw(compat_type(SparkleEffect *) selfPtr, Matrix modelviewMatrix, double deltaTime);

#endif
