/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __STAIRCASE_MODEL_H__
#define __STAIRCASE_MODEL_H__

typedef struct StaircaseModel StaircaseModel;

#include "convergence/GameObjectModel.h"

#define STAIRCASE_RADIUS 0.5f

#define StaircaseModel_structContents \
	GameObjectModel_structContents \
	\
	Vector2 position; \
	bool down;

struct StaircaseModel {
	StaircaseModel_structContents
};

StaircaseModel * StaircaseModel_create(DungeonRoomStateModel * stateModel, Vector2 position, bool down);
void StaircaseModel_init(compat_type(StaircaseModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position, bool down);
void StaircaseModel_initCopy(compat_type(StaircaseModel *) selfPtr, compat_type(StaircaseModel *) originalPtr);
void StaircaseModel_dispose(compat_type(StaircaseModel *) selfPtr);

compat_type(StaircaseModel *) StaircaseModel_copy(compat_type(StaircaseModel *) selfPtr);
struct rect4f StaircaseModel_roughBounds(compat_type(StaircaseModel *) selfPtr);
struct collisionGeometry StaircaseModel_collisionGeometry(compat_type(StaircaseModel *) selfPtr);

#endif
